

#ifndef _INVERSE_KERNEL_H_
#define _INVERSE_KERNEL_H_

#include <stdio.h>
#include "inverse.h"
//#define CHECK_BANK_CONFLICTS 0
//#if CHECK_BANK_CONFLICTS
//#define AS(i, j) CUT_BANK_CHECKER(((float*)&As[0][0]), (BLOCK_SIZE * i + j))
//#define BS(i, j) CUT_BANK_CHECKER(((float*)&Bs[0][0]), (BLOCK_SIZE * i + j))
//#define CS(i,j) CUT_BANK_CHECKER(((float*)&Cs[0][0]),(BLOCK_SIZE * i + j))
//#else
#define AS1(i, j) As1[i][j]
#define BS1(i, j) Bs1[i][j]
#define CS1(i) Cs1[i]
#define AS2(i, j) As2[i][j]
#define BS2(i, j) Bs2[i][j]
#define CS2(i) Cs2[i]
#define AS3(i, j) As3[i][j]
#define BS3(i, j) Bs3[i][j]
#define CS3(i) Cs3[i]
#define AS4(i, j) As4[i][j]
#define BS4(i, j) Bs4[i][j]
#define CS4(i) Cs4[i]
#define AS5(i, j) As5[i][j]
#define BS5(i, j) Bs5[i][j]
#define CS5(i) Cs5[i]
#define AS6(i, j) As6[i][j]
#define BS6(i, j) Bs6[i][j]
#define CS6(i) Cs6[i]
#define AS7(i, j) As7[i][j]
#define BS7(i, j) Bs7[i][j]
#define CS7(i) Cs7[i]
#define AS8(i, j) As8[i][j]
#define BS8(i, j) Bs8[i][j]
#define CS8(i) Cs8[i]
#define AS9(i, j) As9[i][j]
#define BS9(i, j) Bs9[i][j]
#define CS9(i) Cs9[i]
#define AS10(i, j) As10[i][j]
#define BS10(i, j) Bs10[i][j]
#define CS10(i) Cs10[i]
/*#define AS11(i, j) As11[i][j]
#define BS11(i, j) Bs11[i][j]
#define CS11(i) Cs11[i]
#define AS12(i, j) As12[i][j]
#define BS12(i, j) Bs12[i][j]
#define CS12(i) Cs12[i]
#define AS13(i, j) As13[i][j]
#define BS13(i, j) Bs13[i][j]
#define CS13(i) Cs13[i]
#define AS14(i, j) As14[i][j]
#define BS14(i, j) Bs14[i][j]
#define CS14(i) Cs14[i]
#define AS15(i, j) As15[i][j]
#define BS15(i, j) Bs15[i][j]
#define CS15(i) Cs15[i]
#define AS16(i, j) As16[i][j]
#define BS16(i, j) Bs16[i][j]
#define CS16(i) Cs16[i]
#define AS17(i, j) As17[i][j]
#define BS17(i, j) Bs17[i][j]
#define CS17(i) Cs17[i]
#define AS18(i, j) As18[i][j]
#define BS18(i, j) Bs18[i][j]
#define CS18(i) Cs18[i]
#define AS19(i, j) As19[i][j]
#define BS19(i, j) Bs19[i][j]
#define CS19(i) Cs19[i]
#define AS20(i, j) As20[i][j]
#define BS20(i, j) Bs20[i][j]
#define CS20(i) Cs20[i]
#define AS21(i, j) As21[i][j]
#define BS21(i, j) Bs21[i][j]
#define CS21(i) Cs21[i]
#define AS22(i, j) As22[i][j]
#define BS22(i, j) Bs22[i][j]
#define CS22(i) Cs22[i]
#define AS23(i, j) As23[i][j]
#define BS23(i, j) Bs23[i][j]
#define CS23(i) Cs23[i]
#define AS24(i, j) As24[i][j]
#define BS24(i, j) Bs24[i][j]
#define CS24(i) Cs24[i]
#define AS25(i, j) As25[i][j]
#define BS25(i, j) Bs25[i][j]
#define CS25(i) Cs25[i]*/
//#endif

////////////////////////////////////////////////////////////////////////////////
//! Matrix multiplication on the device: C = A * B
//! wA is A's width and wB is B's width
////////////////////////////////////////////////////////////////////////////////
__global__ void
inverse(float** input,int N, int num_arrays)
{
   int num_divs = 10;
   // Block index
   int bx = blockIdx.x;
   // Thread index
   int tx = threadIdx.x;
   int ty = threadIdx.y;
  // int tz = threadIdx.z;
   int i, j, k, itmp,temp,temp1;
   float c, pi, pi1, pj;
   
   
   __shared__ float As1[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As2[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As3[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As4[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As5[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As6[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As7[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As8[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As9[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As10[BLOCK_SIZE][BLOCK_SIZE];
   /*__shared__ float As11[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As12[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As13[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As14[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As15[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As16[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As17[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As18[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As19[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As20[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As21[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As22[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As23[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As24[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float As25[BLOCK_SIZE][BLOCK_SIZE];*/
   __shared__ float Bs1[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs2[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs3[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs4[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs5[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs6[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs7[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs8[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs9[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs10[BLOCK_SIZE][BLOCK_SIZE];
   /*__shared__ float Bs11[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs12[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs13[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs14[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs15[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs16[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs17[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs18[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs19[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs20[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs21[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs22[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs23[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs24[BLOCK_SIZE][BLOCK_SIZE];
   __shared__ float Bs25[BLOCK_SIZE][BLOCK_SIZE];*/
   __shared__ float Cs1[BLOCK_SIZE];
   __shared__ float Cs2[BLOCK_SIZE];
   __shared__ float Cs3[BLOCK_SIZE];
   __shared__ float Cs4[BLOCK_SIZE];
   __shared__ float Cs5[BLOCK_SIZE];
   __shared__ float Cs6[BLOCK_SIZE];
   __shared__ float Cs7[BLOCK_SIZE];
   __shared__ float Cs8[BLOCK_SIZE];
   __shared__ float Cs9[BLOCK_SIZE];
   __shared__ float Cs10[BLOCK_SIZE];
   /*__shared__ float Cs11[BLOCK_SIZE];
   __shared__ float Cs12[BLOCK_SIZE];
   __shared__ float Cs13[BLOCK_SIZE];
   __shared__ float Cs14[BLOCK_SIZE];
   __shared__ float Cs15[BLOCK_SIZE];
   __shared__ float Cs16[BLOCK_SIZE];
   __shared__ float Cs17[BLOCK_SIZE];
   __shared__ float Cs18[BLOCK_SIZE];
   __shared__ float Cs19[BLOCK_SIZE];
   __shared__ float Cs20[BLOCK_SIZE];
   __shared__ float Cs21[BLOCK_SIZE];
   __shared__ float Cs22[BLOCK_SIZE];
   __shared__ float Cs23[BLOCK_SIZE];
   __shared__ float Cs24[BLOCK_SIZE];
   __shared__ float Cs25[BLOCK_SIZE];*/
   __shared__ float indx1[BLOCK_SIZE];
   __shared__ float indx2[BLOCK_SIZE];
   __shared__ float indx3[BLOCK_SIZE];
   __shared__ float indx4[BLOCK_SIZE];
   __shared__ float indx5[BLOCK_SIZE];
   __shared__ float indx6[BLOCK_SIZE];
   __shared__ float indx7[BLOCK_SIZE];
   __shared__ float indx8[BLOCK_SIZE];
   __shared__ float indx9[BLOCK_SIZE];
   __shared__ float indx10[BLOCK_SIZE];
   /*__shared__ float indx11[BLOCK_SIZE];
   __shared__ float indx12[BLOCK_SIZE];
   __shared__ float indx13[BLOCK_SIZE];
   __shared__ float indx14[BLOCK_SIZE];
   __shared__ float indx15[BLOCK_SIZE];
   __shared__ float indx16[BLOCK_SIZE];
   __shared__ float indx17[BLOCK_SIZE];
   __shared__ float indx18[BLOCK_SIZE];
   __shared__ float indx19[BLOCK_SIZE];
   __shared__ float indx20[BLOCK_SIZE];
   __shared__ float indx21[BLOCK_SIZE];
   __shared__ float indx22[BLOCK_SIZE];
   __shared__ float indx23[BLOCK_SIZE];
   __shared__ float indx24[BLOCK_SIZE];
   __shared__ float indx25[BLOCK_SIZE];*/
   __shared__ float c1[BLOCK_SIZE];
   __shared__ float c2[BLOCK_SIZE];
   __shared__ float c3[BLOCK_SIZE];
   __shared__ float c4[BLOCK_SIZE];
   __shared__ float c5[BLOCK_SIZE];
   __shared__ float c6[BLOCK_SIZE];
   __shared__ float c7[BLOCK_SIZE];
   __shared__ float c8[BLOCK_SIZE];
   __shared__ float c9[BLOCK_SIZE];
   __shared__ float c10[BLOCK_SIZE];
   /*__shared__ float c11[BLOCK_SIZE];
   __shared__ float c12[BLOCK_SIZE];
   __shared__ float c13[BLOCK_SIZE];
   __shared__ float c14[BLOCK_SIZE];
   __shared__ float c15[BLOCK_SIZE];
   __shared__ float c16[BLOCK_SIZE];
   __shared__ float c17[BLOCK_SIZE];
   __shared__ float c18[BLOCK_SIZE];
   __shared__ float c19[BLOCK_SIZE];
   __shared__ float c20[BLOCK_SIZE];
   __shared__ float c21[BLOCK_SIZE];
   __shared__ float c22[BLOCK_SIZE];
   __shared__ float c23[BLOCK_SIZE];
   __shared__ float c24[BLOCK_SIZE];
   __shared__ float c25[BLOCK_SIZE];*/
   
   switch(ty) {
      case 0:
         for (i =0; i < N; i ++) {  
            AS1(tx,i) = input[bx][i*N + tx];
            if (i != tx) {
               BS1(tx,i) = 0;
            }
            else {
               BS1(tx,i) = 1;
            }
         }
         if (tx < N) {
            indx1[tx] = tx;
         }
         break;
      case 1:
         for (i =0; i < N; i ++) {
            AS2(tx,i) = input[bx + num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS2(tx,i) = 0;
            }
            else {
               BS2(tx,i) = 1;
            }

            if (tx < N) {
               indx2[tx] = tx;
            }
         }
         break;
      case 2:
         for (i =0; i < N; i ++) {
            AS3(tx,i) = input[bx + 2*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS3(tx,i) = 0;
            }
            else {
               BS3(tx,i) = 1;
            }

            if (tx < N) {
               indx3[tx] = tx;
            }
         }
         break;
      case 3:
         for (i =0; i < N; i ++) {
            AS4(tx,i) = input[bx + 3*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS4(tx,i) = 0;
            }
            else {
               BS4(tx,i) = 1;
            }

            if (tx < N) {
               indx4[tx] = tx;
            }
         }
         break;
      case 4:
         for (i =0; i < N; i ++) {
            AS5(tx,i) = input[bx + 4*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS5(tx,i) = 0;
            }
            else {
               BS5(tx,i) = 1;
            }

            if (tx < N) {
               indx5[tx] = tx;
            }
         }
         break;
      case 5:
         for (i =0; i < N; i ++) {
            AS6(tx,i) = input[bx + 5*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS6(tx,i) = 0;
            }
            else {
               BS6(tx,i) = 1;
            }

            if (tx < N) {
               indx6[tx] = tx;
            }
         }
         break;
      case 6:
         for (i =0; i < N; i ++) {
            AS7(tx,i) = input[bx + 6*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS7(tx,i) = 0;
            }
            else {
               BS7(tx,i) = 1;
            }

            if (tx < N) {
               indx7[tx] = tx;
            }
         }
         break;
      case 7:
         for (i =0; i < N; i ++) {
            AS8(tx,i) = input[bx + 7*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS8(tx,i) = 0;
            }
            else {
               BS8(tx,i) = 1;
            }

            if (tx < N) {
               indx8[tx] = tx;
            }
         }
         break;
      case 8:
         for (i =0; i < N; i ++) {
            AS9(tx,i) = input[bx + 8*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS9(tx,i) = 0;
            }
            else {
               BS9(tx,i) = 1;
            }

            if (tx < N) {
               indx9[tx] = tx;
            }
         }
         break;
      case 9:
         for (i =0; i < N; i ++) {
            AS10(tx,i) = input[bx + 9*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS10(tx,i) = 0;
            }
            else {
               BS10(tx,i) = 1;
            }

            if (tx < N) {
               indx10[tx] = tx;
            }
         }
         /*break;
      case 10:
         for (i =0; i < N; i ++) {  
            AS11(tx,i) = input[bx + 10*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS11(tx,i) = 0;
            }
            else {
               BS11(tx,i) = 1;
            }
         }
         if (tx < N) {
            indx11[tx] = tx;
         }
         break;
      case 11:
         for (i =0; i < N; i ++) {
            AS12(tx,i) = input[bx + 11*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS12(tx,i) = 0;
            }
            else {
               BS12(tx,i) = 1;
            }

            if (tx < N) {
               indx12[tx] = tx;
            }
         }
         break;
      case 12:
         for (i =0; i < N; i ++) {
            AS13(tx,i) = input[bx + 12*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS13(tx,i) = 0;
            }
            else {
               BS13(tx,i) = 1;
            }

            if (tx < N) {
               indx13[tx] = tx;
            }
         }
         break;
      case 13:
         for (i =0; i < N; i ++) {
            AS14(tx,i) = input[bx + 13*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS14(tx,i) = 0;
            }
            else {
               BS14(tx,i) = 1;
            }

            if (tx < N) {
               indx14[tx] = tx;
            }
         }
         break;
      case 14:
         for (i =0; i < N; i ++) {
            AS15(tx,i) = input[bx + 14*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS15(tx,i) = 0;
            }
            else {
               BS15(tx,i) = 1;
            }

            if (tx < N) {
               indx15[tx] = tx;
            }
         }
         break;
      case 15:
         for (i =0; i < N; i ++) {
            AS16(tx,i) = input[bx + 15*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS16(tx,i) = 0;
            }
            else {
               BS16(tx,i) = 1;
            }

            if (tx < N) {
               indx16[tx] = tx;
            }
         }
         break;
      case 16:
         for (i =0; i < N; i ++) {
            AS17(tx,i) = input[bx + 16*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS17(tx,i) = 0;
            }
            else {
               BS17(tx,i) = 1;
            }

            if (tx < N) {
               indx17[tx] = tx;
            }
         }
         break;
      case 17:
         for (i =0; i < N; i ++) {
            AS18(tx,i) = input[bx + 17*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS18(tx,i) = 0;
            }
            else {
               BS18(tx,i) = 1;
            }

            if (tx < N) {
               indx18[tx] = tx;
            }
         }
         break;
      case 18:
         for (i =0; i < N; i ++) {
            AS19(tx,i) = input[bx + 18*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS19(tx,i) = 0;
            }
            else {
               BS19(tx,i) = 1;
            }

            if (tx < N) {
               indx19[tx] = tx;
            }
         }
         break;
      case 19:
         for (i =0; i < N; i ++) {
            AS20(tx,i) = input[bx + 19*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS20(tx,i) = 0;
            }
            else {
               BS20(tx,i) = 1;
            }

            if (tx < N) {
               indx20[tx] = tx;
            }
         }
          break;
      case 20:
         for (i =0; i < N; i ++) {
            AS21(tx,i) = input[bx + 20*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS21(tx,i) = 0;
            }
            else {
               BS21(tx,i) = 1;
            }

            if (tx < N) {
               indx21[tx] = tx;
            }
         }
         break;
      case 21:
         for (i =0; i < N; i ++) {
            AS22(tx,i) = input[bx + 21*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS22(tx,i) = 0;
            }
            else {
               BS22(tx,i) = 1;
            }

            if (tx < N) {
               indx22[tx] = tx;
            }
         }
         break;
      case 22:
         for (i =0; i < N; i ++) {
            AS23(tx,i) = input[bx + 22*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS23(tx,i) = 0;
            }
            else {
               BS23(tx,i) = 1;
            }

            if (tx < N) {
               indx23[tx] = tx;
            }
         }
         break;
      case 23:
         for (i =0; i < N; i ++) {
            AS24(tx,i) = input[bx + 23*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS24(tx,i) = 0;
            }
            else {
               BS24(tx,i) = 1;
            }

            if (tx < N) {
               indx24[tx] = tx;
            }
         }
         break;
      case 24:
         for (i =0; i < N; i ++) {
            AS25(tx,i) = input[bx + 24*num_arrays/num_divs][i*N + tx];
            if (i != tx) {
               BS25(tx,i) = 0;
            }
            else {
               BS25(tx,i) = 1;
            }

            if (tx < N) {
               indx25[tx] = tx;
            }
         }*/
   }
   __syncthreads(); 
    
    
   // Find the rescaling factors, one from each row
   switch(ty) {
      case 0:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS1(tx,i)) > c) { 
                  c = fabs(AS1(tx,i));
               }
            }
            c1[tx] = c;
         }
         break;
      case 1:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS2(tx,i)) > c) { 
                  c = fabs(AS2(tx,i));
               }
            }
            c2[tx] = c;
         }
         break;
      case 2:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS3(tx,i)) > c) { 
                  c = fabs(AS3(tx,i));
               }
            }
            c3[tx] = c;
         }
         break;
      case 3:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS4(tx,i)) > c) { 
                  c = fabs(AS4(tx,i));
               }
            }
            c4[tx] = c;
         }
         break;
      case 4:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS5(tx,i)) > c) { 
                  c = fabs(AS5(tx,i));
               }
            }
            c5[tx] = c;
         }
         break;
      case 5:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS6(tx,i)) > c) { 
                  c = fabs(AS6(tx,i));
               }
            }
            c6[tx] = c;
         }
         break;
      case 6:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS7(tx,i)) > c) { 
                  c = fabs(AS7(tx,i));
               }
            }
            c7[tx] = c;
         }
         break;
      case 7:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS8(tx,i)) > c) { 
                  c = fabs(AS8(tx,i));
               }
            }
            c8[tx] = c;
         }
         break;
      case 8:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS9(tx,i)) > c) { 
                  c = fabs(AS9(tx,i));
               }
            }
            c9[tx] = c;
         }
         break;
      case 9:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS10(tx,i)) > c) { 
                  c = fabs(AS10(tx,i));
               }
            }
            c10[tx] = c;
         }
        /* break;
      case 10:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS11(tx,i)) > c) { 
                  c = fabs(AS11(tx,i));
               }
            }
            c11[tx] = c;
         }
         break;
      case 11:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS12(tx,i)) > c) { 
                  c = fabs(AS12(tx,i));
               }
            }
            c12[tx] = c;
         }
         break;
      case 12:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS13(tx,i)) > c) { 
                  c = fabs(AS13(tx,i));
               }
            }
            c13[tx] = c;
         }
         break;
      case 13:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS14(tx,i)) > c) { 
                  c = fabs(AS14(tx,i));
               }
            }
            c14[tx] = c;
         }
         break;
      case 14:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS15(tx,i)) > c) { 
                  c = fabs(AS15(tx,i));
               }
            }
            c15[tx] = c;
         }
         break;
      case 15:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS16(tx,i)) > c) { 
                  c = fabs(AS16(tx,i));
               }
            }
            c16[tx] = c;
         }
         break;
      case 16:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS17(tx,i)) > c) { 
                  c = fabs(AS17(tx,i));
               }
            }
            c17[tx] = c;
         }
         break;
      case 17:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS18(tx,i)) > c) { 
                  c = fabs(AS18(tx,i));
               }
            }
            c18[tx] = c;
         }
         break;
      case 18:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS19(tx,i)) > c) { 
                  c = fabs(AS19(tx,i));
               }
            }
            c19[tx] = c;
         }
         break;
      case 19:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS20(tx,i)) > c) { 
                  c = fabs(AS20(tx,i));
               }
            }
            c20[tx] = c;
         }
         break;
      case 20:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS21(tx,i)) > c) { 
                  c = fabs(AS21(tx,i));
               }
            }
            c21[tx] = c;
         }
         break;
      case 21:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS22(tx,i)) > c) { 
                  c = fabs(AS22(tx,i));
               }
            }
            c22[tx] = c;
         }
         break;
      case 22:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS23(tx,i)) > c) { 
                  c = fabs(AS23(tx,i));
               }
            }
            c23[tx] = c;
         }
         break;
      case 23:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS24(tx,i)) > c) { 
                  c = fabs(AS24(tx,i));
               }
            }
            c24[tx] = c;
         }
         break;
      case 24:
         if (tx < N) {
            c = 0;
            for (i =0; i < N; i++) {
               if (fabs(AS25(tx,i)) > c) { 
                  c = fabs(AS25(tx,i));
               }
            }
            c25[tx] = c;
         }*/
   }
   __syncthreads();
   
   switch(ty) {
      case 0:
         if (tx ==0) {
            for (j = 0; j < N-1; ++j) {
               pi1 = 0;
               for (i = j; i < N; ++i) {
                  temp = indx1[i];
                  pi = fabs(AS1(temp,j)/c1[temp]);
                  if (pi > pi1) { 
                     pi1 = pi;
                     k = i;
                  }
               }
       
       // Interchange the rows via indx[] to record pivoting order
 
               itmp = indx1[j]; 
               indx1[j] = indx1[k];
               indx1[k] = itmp;
               for (i = j+1; i < N; ++i) {
                  temp = indx1[i];
                  temp1 = indx1[j];
                  pj = AS1(temp,j)/AS1(temp1,j);
      // Record pivoting ratios below the diagonal

                  AS1(temp,j) = pj;

      // Modify other elements accordingly
   
                  for (k = j+1; k < N; ++k) {
                     temp1 = indx1[j];
                     AS1(temp,k) = AS1(temp,k)-pj*AS1(temp1,k);
                  }
               }
            }
         }      
         break;
     case 1:
        if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx2[i];
                 pi = fabs(AS2(temp,j)/c2[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx2[j]; 
              indx2[j] = indx2[k];
              indx2[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx2[i];
                 temp1 = indx2[j];
                 pj = AS2(temp,j)/AS2(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS2(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx2[j];
                    AS2(temp,k) = AS2(temp,k)-pj*AS2(temp1,k);
                 }
              }
           }
        }
        break;   
      case 2:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx3[i];
                 pi = fabs(AS3(temp,j)/c3[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx3[j]; 
              indx3[j] = indx3[k];
              indx3[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx3[i];
                 temp1 = indx3[j];
                 pj = AS3(temp,j)/AS3(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS3(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx3[j];
                    AS3(temp,k) = AS3(temp,k)-pj*AS3(temp1,k);
                 }
              }
           }
        }
        break;
      case 3:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx4[i];
                 pi = fabs(AS4(temp,j)/c4[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx4[j]; 
              indx4[j] = indx4[k];
              indx4[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx4[i];
                 temp1 = indx4[j];
                 pj = AS4(temp,j)/AS4(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS4(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx4[j];
                    AS4(temp,k) = AS4(temp,k)-pj*AS4(temp1,k);
                 }
              }
           }
        }
        break;
      case 4:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx5[i];
                 pi = fabs(AS5(temp,j)/c5[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx5[j]; 
              indx5[j] = indx5[k];
              indx5[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx5[i];
                 temp1 = indx5[j];
                 pj = AS5(temp,j)/AS5(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS5(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx5[j];
                    AS5(temp,k) = AS5(temp,k)-pj*AS5(temp1,k);
                 }
              }
           }
         }
         break;
      case 5:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx6[i];
                 pi = fabs(AS6(temp,j)/c6[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx6[j]; 
              indx6[j] = indx6[k];
              indx6[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx6[i];
                 temp1 = indx6[j];
                 pj = AS6(temp,j)/AS6(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS6(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx6[j];
                    AS6(temp,k) = AS6(temp,k)-pj*AS6(temp1,k);
                 }
              }
           }
        }
        break;
      case 6:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx7[i];
                 pi = fabs(AS7(temp,j)/c7[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx7[j]; 
              indx7[j] = indx7[k];
              indx7[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx7[i];
                 temp1 = indx7[j];
                 pj = AS7(temp,j)/AS7(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS7(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx7[j];
                    AS7(temp,k) = AS7(temp,k)-pj*AS7(temp1,k);
                 }
              }
           }
        }
        break;
      case 7:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx8[i];
                 pi = fabs(AS8(temp,j)/c8[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx8[j]; 
              indx8[j] = indx8[k];
              indx8[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx8[i];
                 temp1 = indx8[j];
                 pj = AS8(temp,j)/AS8(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS8(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx8[j];
                    AS8(temp,k) = AS8(temp,k)-pj*AS8(temp1,k);
                 }
              }
           }
        }
        break;
      case 8:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx9[i];
                 pi = fabs(AS9(temp,j)/c9[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx9[j]; 
              indx9[j] = indx9[k];
              indx9[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx9[i];
                 temp1 = indx9[j];
                 pj = AS9(temp,j)/AS9(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS9(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx9[j];
                    AS9(temp,k) = AS9(temp,k)-pj*AS9(temp1,k);
                 }
              }
           }
        }
        break;
      case 9:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx10[i];
                 pi = fabs(AS10(temp,j)/c10[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx10[j]; 
              indx10[j] = indx10[k];
              indx10[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx10[i];
                 temp1 = indx10[j];
                 pj = AS10(temp,j)/AS10(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS10(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx10[j];
                    AS10(temp,k) = AS10(temp,k)-pj*AS10(temp1,k);
                 }
              }
           }
        }
       /* break;
      case 10:
         if (tx ==0) {
            for (j = 0; j < N-1; ++j) {
               pi1 = 0;
               for (i = j; i < N; ++i) {
                  temp = indx11[i];
                  pi = fabs(AS11(temp,j)/c11[temp]);
                  if (pi > pi1) { 
                     pi1 = pi;
                     k = i;
                  }
               }
       
       // Interchange the rows via indx[] to record pivoting order
 
               itmp = indx11[j]; 
               indx11[j] = indx11[k];
               indx11[k] = itmp;
               for (i = j+1; i < N; ++i) {
                  temp = indx11[i];
                  temp1 = indx11[j];
                  pj = AS11(temp,j)/AS11(temp1,j);
      // Record pivoting ratios below the diagonal

                  AS11(temp,j) = pj;

      // Modify other elements accordingly
   
                  for (k = j+1; k < N; ++k) {
                     temp1 = indx11[j];
                     AS11(temp,k) = AS11(temp,k)-pj*AS11(temp1,k);
                  }
               }
            }
         }      
         break;
     case 11:
        if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx12[i];
                 pi = fabs(AS12(temp,j)/c12[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx12[j]; 
              indx12[j] = indx12[k];
              indx12[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx12[i];
                 temp1 = indx12[j];
                 pj = AS12(temp,j)/AS12(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS12(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx12[j];
                    AS12(temp,k) = AS12(temp,k)-pj*AS12(temp1,k);
                 }
              }
           }
        }
        break;   
      case 12:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx13[i];
                 pi = fabs(AS13(temp,j)/c13[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx13[j]; 
              indx13[j] = indx13[k];
              indx13[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx13[i];
                 temp1 = indx13[j];
                 pj = AS13(temp,j)/AS13(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS13(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx13[j];
                    AS13(temp,k) = AS13(temp,k)-pj*AS13(temp1,k);
                 }
              }
           }
        }
        break;
      case 13:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx14[i];
                 pi = fabs(AS14(temp,j)/c14[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx14[j]; 
              indx14[j] = indx14[k];
              indx14[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx14[i];
                 temp1 = indx14[j];
                 pj = AS14(temp,j)/AS14(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS14(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx14[j];
                    AS14(temp,k) = AS14(temp,k)-pj*AS14(temp1,k);
                 }
              }
           }
        }
        break;
      case 14:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx15[i];
                 pi = fabs(AS15(temp,j)/c15[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx15[j]; 
              indx15[j] = indx15[k];
              indx15[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx15[i];
                 temp1 = indx15[j];
                 pj = AS15(temp,j)/AS15(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS15(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx15[j];
                    AS15(temp,k) = AS15(temp,k)-pj*AS15(temp1,k);
                 }
              }
           }
         }
         break;
      case 15:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx16[i];
                 pi = fabs(AS16(temp,j)/c16[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx16[j]; 
              indx16[j] = indx16[k];
              indx16[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx16[i];
                 temp1 = indx16[j];
                 pj = AS16(temp,j)/AS16(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS16(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx16[j];
                    AS16(temp,k) = AS16(temp,k)-pj*AS16(temp1,k);
                 }
              }
           }
        }
        break;
      case 16:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx17[i];
                 pi = fabs(AS17(temp,j)/c17[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx17[j]; 
              indx17[j] = indx17[k];
              indx17[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx17[i];
                 temp1 = indx17[j];
                 pj = AS17(temp,j)/AS17(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS17(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx17[j];
                    AS17(temp,k) = AS17(temp,k)-pj*AS17(temp1,k);
                 }
              }
           }
        }
        break;
      case 17:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx18[i];
                 pi = fabs(AS18(temp,j)/c18[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx18[j]; 
              indx18[j] = indx18[k];
              indx18[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx18[i];
                 temp1 = indx18[j];
                 pj = AS18(temp,j)/AS18(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS18(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx18[j];
                    AS18(temp,k) = AS18(temp,k)-pj*AS18(temp1,k);
                 }
              }
           }
        }
        break;
      case 18:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx19[i];
                 pi = fabs(AS19(temp,j)/c19[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx19[j]; 
              indx19[j] = indx19[k];
              indx19[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx19[i];
                 temp1 = indx19[j];
                 pj = AS19(temp,j)/AS19(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS19(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx19[j];
                    AS19(temp,k) = AS19(temp,k)-pj*AS19(temp1,k);
                 }
              }
           }
        }
        break;
      case 19:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx20[i];
                 pi = fabs(AS20(temp,j)/c20[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx20[j]; 
              indx20[j] = indx20[k];
              indx20[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx20[i];
                 temp1 = indx20[j];
                 pj = AS20(temp,j)/AS20(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS20(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx20[j];
                    AS20(temp,k) = AS20(temp,k)-pj*AS20(temp1,k);
                 }
              }
           }
        }
        break;
      case 20:
         if (tx ==0) {
            for (j = 0; j < N-1; ++j) {
               pi1 = 0;
               for (i = j; i < N; ++i) {
                  temp = indx21[i];
                  pi = fabs(AS21(temp,j)/c21[temp]);
                  if (pi > pi1) { 
                     pi1 = pi;
                     k = i;
                  }
               }
       
       // Interchange the rows via indx[] to record pivoting order
 
               itmp = indx21[j]; 
               indx21[j] = indx21[k];
               indx21[k] = itmp;
               for (i = j+1; i < N; ++i) {
                  temp = indx21[i];
                  temp1 = indx21[j];
                  pj = AS21(temp,j)/AS21(temp1,j);
      // Record pivoting ratios below the diagonal

                  AS21(temp,j) = pj;

      // Modify other elements accordingly
   
                  for (k = j+1; k < N; ++k) {
                     temp1 = indx21[j];
                     AS21(temp,k) = AS21(temp,k)-pj*AS21(temp1,k);
                  }
               }
            }
         }      
         break;
     case 21:
        if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx22[i];
                 pi = fabs(AS22(temp,j)/c22[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx22[j]; 
              indx22[j] = indx22[k];
              indx22[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx22[i];
                 temp1 = indx22[j];
                 pj = AS22(temp,j)/AS22(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS22(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx22[j];
                    AS22(temp,k) = AS22(temp,k)-pj*AS22(temp1,k);
                 }
              }
           }
        }
        break;   
      case 22:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx23[i];
                 pi = fabs(AS23(temp,j)/c23[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx23[j]; 
              indx23[j] = indx23[k];
              indx23[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx23[i];
                 temp1 = indx23[j];
                 pj = AS23(temp,j)/AS23(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS23(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx23[j];
                    AS23(temp,k) = AS23(temp,k)-pj*AS23(temp1,k);
                 }
              }
           }
        }
        break;
      case 23:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx24[i];
                 pi = fabs(AS24(temp,j)/c24[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx24[j]; 
              indx24[j] = indx24[k];
              indx24[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx24[i];
                 temp1 = indx24[j];
                 pj = AS24(temp,j)/AS24(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS24(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx24[j];
                    AS24(temp,k) = AS24(temp,k)-pj*AS24(temp1,k);
                 }
              }
           }
        }
        break;
      case 24:
         if (tx ==0) {
           for (j = 0; j < N-1; ++j) {
              pi1 = 0;
              for (i = j; i < N; ++i) {
                 temp = indx25[i];
                 pi = fabs(AS25(temp,j)/c25[temp]);
                 if (pi > pi1) { 
                    pi1 = pi;
                    k = i;
                 }
              }
    
       // Interchange the rows via indx[] to record pivoting order

              itmp = indx25[j]; 
              indx25[j] = indx25[k];
              indx25[k] = itmp;
              for (i = j+1; i < N; ++i) {
                 temp = indx25[i];
                 temp1 = indx25[j];
                 pj = AS25(temp,j)/AS25(temp1,j);
      // Record pivoting ratios below the diagonal

                 AS25(temp,j) = pj;
  
      // Modify other elements accordingly

                 for (k = j+1; k < N; ++k) {
                    temp1 = indx25[j];
                    AS25(temp,k) = AS25(temp,k)-pj*AS25(temp1,k);
                 }
              }
           }
         }*/
   } 
   __syncthreads();
   
   switch(ty) {
      case 0:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx1[j];
                     temp1 = indx1[i];
                     BS1(temp,k) = BS1(temp,k)- AS1(temp,i)*BS1(temp1,k);
                  }
               }
            }
         }
         break;
      case 1:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx2[j];
                     temp1 = indx2[i];
                     BS2(temp,k) = BS2(temp,k)- AS2(temp,i)*BS2(temp1,k);
                  }
               }
            }
         }
         break;
      case 2:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx3[j];
                     temp1 = indx3[i];
                     BS3(temp,k) = BS3(temp,k)- AS3(temp,i)*BS3(temp1,k);
                  }
               }
            }
         }
         break;
      case 3:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx4[j];
                     temp1 = indx4[i];
                     BS4(temp,k) = BS4(temp,k)- AS4(temp,i)*BS4(temp1,k);
                  }
               }
            }
         }
         break;
      case 4:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx5[j];
                     temp1 = indx5[i];
                     BS5(temp,k) = BS5(temp,k)- AS5(temp,i)*BS5(temp1,k);
                  }
               }
            }
         }
         break;
      case 5:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx6[j];
                     temp1 = indx6[i];
                     BS6(temp,k) = BS6(temp,k)- AS6(temp,i)*BS6(temp1,k);
                  }
               }
            }
         }
         break;
      case 6:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx7[j];
                     temp1 = indx7[i];
                     BS7(temp,k) = BS7(temp,k)- AS7(temp,i)*BS7(temp1,k);
                  }
               }
            }
         }
         break;
      case 7:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx8[j];
                     temp1 = indx8[i];
                     BS8(temp,k) = BS8(temp,k)- AS8(temp,i)*BS8(temp1,k);
                  }
               }
            }
         }
         break;
      case 8:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx9[j];
                     temp1 = indx9[i];
                     BS9(temp,k) = BS9(temp,k)- AS9(temp,i)*BS9(temp1,k);
                  }
               }
            }
         }
         break;
      case 9:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx10[j];
                     temp1 = indx10[i];
                     BS10(temp,k) = BS10(temp,k)- AS10(temp,i)*BS10(temp1,k);
                  }
               }
            }
         }
         /*break;
      case 10:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx11[j];
                     temp1 = indx11[i];
                     BS11(temp,k) = BS11(temp,k)- AS11(temp,i)*BS11(temp1,k);
                  }
               }
            }
         }
         break;
      case 11:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx12[j];
                     temp1 = indx12[i];
                     BS12(temp,k) = BS12(temp,k)- AS12(temp,i)*BS12(temp1,k);
                  }
               }
            }
         }
         break;
      case 12:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx13[j];
                     temp1 = indx13[i];
                     BS13(temp,k) = BS13(temp,k)- AS13(temp,i)*BS13(temp1,k);
                  }
               }
            }
         }
         break;
      case 13:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx14[j];
                     temp1 = indx14[i];
                     BS14(temp,k) = BS14(temp,k)- AS14(temp,i)*BS14(temp1,k);
                  }
               }
            }
         }
         break;
      case 14:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx15[j];
                     temp1 = indx15[i];
                     BS15(temp,k) = BS15(temp,k)- AS15(temp,i)*BS15(temp1,k);
                  }
               }
            }
         }
         break;
      case 15:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx16[j];
                     temp1 = indx16[i];
                     BS16(temp,k) = BS16(temp,k)- AS16(temp,i)*BS16(temp1,k);
                  }
               }
            }
         }
         break;
      case 16:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx17[j];
                     temp1 = indx17[i];
                     BS17(temp,k) = BS17(temp,k)- AS17(temp,i)*BS17(temp1,k);
                  }
               }
            }
         }
         break;
      case 17:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx18[j];
                     temp1 = indx18[i];
                     BS18(temp,k) = BS18(temp,k)- AS18(temp,i)*BS18(temp1,k);
                  }
               }
            }
         }
         break;
      case 18:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx19[j];
                     temp1 = indx19[i];
                     BS19(temp,k) = BS19(temp,k)- AS19(temp,i)*BS19(temp1,k);
                  }
               }
            }
         }
         break;
      case 19:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx20[j];
                     temp1 = indx20[i];
                     BS20(temp,k) = BS20(temp,k)- AS20(temp,i)*BS20(temp1,k);
                  }
               }
            }
         }
         break;
      case 20:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx21[j];
                     temp1 = indx21[i];
                     BS21(temp,k) = BS21(temp,k)- AS21(temp,i)*BS21(temp1,k);
                  }
               }
            }
         }
         break;
      case 21:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx22[j];
                     temp1 = indx22[i];
                     BS22(temp,k) = BS22(temp,k)- AS22(temp,i)*BS22(temp1,k);
                  }
               }
            }
         }
         break;
      case 22:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx23[j];
                     temp1 = indx23[i];
                     BS23(temp,k) = BS23(temp,k)- AS23(temp,i)*BS23(temp1,k);
                  }
               }
            }
         }
         break;
      case 23:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx24[j];
                     temp1 = indx24[i];
                     BS24(temp,k) = BS24(temp,k)- AS24(temp,i)*BS24(temp1,k);
                  }
               }
            }
         }
         break;
      case 24:
         if (tx==0) {
            for (i=0;i<N-1;++i) {
               for (j=i+1;j <N;++j) {
                  for (k = 0; k < N; ++k) {
                     temp = indx25[j];
                     temp1 = indx25[i];
                     BS25(temp,k) = BS25(temp,k)- AS25(temp,i)*BS25(temp1,k);
                  }
               }
            }
         }*/
   }
   __syncthreads();
   
   switch(ty) {
      case 0:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx1[N-1];
               CS1(N-1) = BS1(temp,i)/AS1(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx1[j];
                  CS1(j) = BS1(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS1(j) = CS1(j)-AS1(temp,k)*CS1(k);
                  }
                  CS1(j) = CS1(j)/AS1(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx][i*N +j] = CS1(j);
               }
            }
         }
         break;
      case 1:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx2[N-1];
               CS2(N-1) = BS2(temp,i)/AS2(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx2[j];
                  CS2(j) = BS2(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS2(j) = CS2(j)-AS2(temp,k)*CS2(k);
                  }
                  CS2(j) = CS2(j)/AS2(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + num_arrays/num_divs][i*N +j] = CS2(j);
               }
            }
         }
         break;
      case 2:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx3[N-1];
               CS3(N-1) = BS3(temp,i)/AS3(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx3[j];
                  CS3(j) = BS3(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS3(j) = CS3(j)-AS3(temp,k)*CS3(k);
                  }
                  CS3(j) = CS3(j)/AS3(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 2*num_arrays/num_divs][i*N +j] = CS3(j);
               }
            }
         }
      case 3:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx4[N-1];
               CS4(N-1) = BS4(temp,i)/AS4(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx4[j];
                  CS4(j) = BS4(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS4(j) = CS4(j)-AS4(temp,k)*CS4(k);
                  }
                  CS4(j) = CS4(j)/AS4(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 3*num_arrays/num_divs][i*N +j] = CS4(j);
               }
            }
         }
      case 4:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx5[N-1];
               CS5(N-1) = BS5(temp,i)/AS5(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx5[j];
                  CS5(j) = BS5(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS5(j) = CS5(j)-AS5(temp,k)*CS5(k);
                  }
                  CS5(j) = CS5(j)/AS5(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 4*num_arrays/num_divs][i*N +j] = CS5(j);
               }
            }
         }
         break;
      case 5:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx6[N-1];
               CS6(N-1) = BS6(temp,i)/AS6(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx6[j];
                  CS6(j) = BS6(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS6(j) = CS6(j)-AS6(temp,k)*CS6(k);
                  }
                  CS6(j) = CS6(j)/AS6(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 5*num_arrays/num_divs][i*N +j] = CS6(j);
               }
            }
         }
         break;
      case 6:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx7[N-1];
               CS7(N-1) = BS7(temp,i)/AS7(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx7[j];
                  CS7(j) = BS7(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS7(j) = CS7(j)-AS7(temp,k)*CS7(k);
                  }
                  CS7(j) = CS7(j)/AS7(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 6*num_arrays/num_divs][i*N +j] = CS7(j);
               }
            }
         }
         break;
      case 7:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx8[N-1];
               CS8(N-1) = BS8(temp,i)/AS8(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx8[j];
                  CS8(j) = BS8(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS8(j) = CS8(j)-AS8(temp,k)*CS8(k);
                  }
                  CS8(j) = CS8(j)/AS8(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 7*num_arrays/num_divs][i*N +j] = CS8(j);
               }
            }
         }
         break;
      case 8:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx9[N-1];
               CS9(N-1) = BS9(temp,i)/AS9(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx9[j];
                  CS9(j) = BS9(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS9(j) = CS9(j)-AS9(temp,k)*CS9(k);
                  }
                  CS9(j) = CS9(j)/AS9(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 8*num_arrays/num_divs][i*N +j] = CS9(j);
               }
            }
         }
         break;
      case 9:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx10[N-1];
               CS10(N-1) = BS10(temp,i)/AS10(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx10[j];
                  CS10(j) = BS10(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS10(j) = CS10(j)-AS10(temp,k)*CS10(k);
                  }
                  CS10(j) = CS10(j)/AS10(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 9*num_arrays/num_divs][i*N +j] = CS10(j);
               }
            }
         }
         /*break;
      case 10:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx11[N-1];
               CS11(N-1) = BS11(temp,i)/AS11(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx11[j];
                  CS11(j) = BS11(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS11(j) = CS11(j)-AS11(temp,k)*CS11(k);
                  }
                  CS11(j) = CS11(j)/AS11(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 10*num_arrays/num_divs][i*N +j] = CS11(j);
               }
            }
         }
         break;
      case 11:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx12[N-1];
               CS12(N-1) = BS12(temp,i)/AS12(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx12[j];
                  CS12(j) = BS12(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS12(j) = CS12(j)-AS12(temp,k)*CS12(k);
                  }
                  CS12(j) = CS12(j)/AS12(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 11*num_arrays/num_divs][i*N +j] = CS12(j);
               }
            }
         }
         break;
      case 12:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx13[N-1];
               CS13(N-1) = BS13(temp,i)/AS13(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx13[j];
                  CS13(j) = BS13(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS13(j) = CS13(j)-AS13(temp,k)*CS13(k);
                  }
                  CS13(j) = CS13(j)/AS13(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 12*num_arrays/num_divs][i*N +j] = CS13(j);
               }
            }
         }
      case 13:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx14[N-1];
               CS14(N-1) = BS14(temp,i)/AS14(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx14[j];
                  CS14(j) = BS14(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS14(j) = CS14(j)-AS14(temp,k)*CS14(k);
                  }
                  CS14(j) = CS14(j)/AS14(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 13*num_arrays/num_divs][i*N +j] = CS14(j);
               }
            }
         }
      case 14:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx15[N-1];
               CS15(N-1) = BS15(temp,i)/AS15(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx15[j];
                  CS15(j) = BS15(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS15(j) = CS15(j)-AS15(temp,k)*CS15(k);
                  }
                  CS15(j) = CS15(j)/AS15(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 14*num_arrays/num_divs][i*N +j] = CS15(j);
               }
            }
         }
         break;
      case 15:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx16[N-1];
               CS16(N-1) = BS16(temp,i)/AS16(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx16[j];
                  CS16(j) = BS16(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS16(j) = CS16(j)-AS16(temp,k)*CS16(k);
                  }
                  CS16(j) = CS16(j)/AS16(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 15*num_arrays/num_divs][i*N +j] = CS16(j);
               }
            }
         }
         break;
      case 16:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx7[N-1];
               CS17(N-1) = BS17(temp,i)/AS17(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx17[j];
                  CS17(j) = BS17(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS17(j) = CS17(j)-AS17(temp,k)*CS17(k);
                  }
                  CS17(j) = CS17(j)/AS17(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 16*num_arrays/num_divs][i*N +j] = CS17(j);
               }
            }
         }
         break;
      case 17:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx8[N-1];
               CS18(N-1) = BS18(temp,i)/AS18(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx18[j];
                  CS18(j) = BS18(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS18(j) = CS18(j)-AS18(temp,k)*CS18(k);
                  }
                  CS18(j) = CS18(j)/AS18(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 17*num_arrays/num_divs][i*N +j] = CS18(j);
               }
            }
         }
         break;
      case 18:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx19[N-1];
               CS19(N-1) = BS19(temp,i)/AS19(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx19[j];
                  CS19(j) = BS19(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS19(j) = CS19(j)-AS19(temp,k)*CS19(k);
                  }
                  CS19(j) = CS19(j)/AS19(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 18*num_arrays/num_divs][i*N +j] = CS19(j);
               }
            }
         }
         break;
      case 19:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx20[N-1];
               CS20(N-1) = BS20(temp,i)/AS20(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx20[j];
                  CS20(j) = BS20(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS20(j) = CS20(j)-AS20(temp,k)*CS20(k);
                  }
                  CS20(j) = CS20(j)/AS20(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 19*num_arrays/num_divs][i*N +j] = CS20(j);
               }
            }
         }
         break;
      case 20:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx21[N-1];
               CS21(N-1) = BS21(temp,i)/AS21(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx21[j];
                  CS21(j) = BS21(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS21(j) = CS21(j)-AS21(temp,k)*CS21(k);
                  }
                  CS21(j) = CS21(j)/AS21(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 20*num_arrays/num_divs][i*N +j] = CS21(j);
               }
            }
         }
         break;
      case 21:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx22[N-1];
               CS22(N-1) = BS22(temp,i)/AS22(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx22[j];
                  CS22(j) = BS22(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS22(j) = CS22(j)-AS22(temp,k)*CS22(k);
                  }
                  CS22(j) = CS22(j)/AS22(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 21*num_arrays/num_divs][i*N +j] = CS22(j);
               }
            }
         }
         break;
      case 22:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx23[N-1];
               CS23(N-1) = BS23(temp,i)/AS23(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx23[j];
                  CS23(j) = BS23(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS23(j) = CS23(j)-AS23(temp,k)*CS23(k);
                  }
                  CS23(j) = CS23(j)/AS23(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 22*num_arrays/num_divs][i*N +j] = CS23(j);
               }
            }
         }
      case 23:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx24[N-1];
               CS24(N-1) = BS24(temp,i)/AS24(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx24[j];
                  CS24(j) = BS24(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS24(j) = CS24(j)-AS24(temp,k)*CS24(k);
                  }
                  CS24(j) = CS24(j)/AS24(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 23*num_arrays/num_divs][i*N +j] = CS24(j);
               }
            }
         }
      case 24:
         if (tx==0) {
            for (i = 0; i < N; ++i) {
               temp = indx25[N-1];
               CS25(N-1) = BS25(temp,i)/AS25(temp,N-1);
               for (j = N-2; j >= 0; j = j-1) {
                  temp = indx25[j];
                  CS25(j) = BS25(temp,i);
                  for (k = j+1; k < N; ++k) {
                     CS25(j) = CS25(j)-AS25(temp,k)*CS25(k);
                  }
                  CS25(j) = CS25(j)/AS25(temp,j);
               }
               for (j=0;j<N;j++) {
                  input[bx + 24*num_arrays/num_divs][i*N +j] = CS25(j);
               }
            }
         }*/
   }
   __syncthreads();
  
     
}

#endif // #ifndef _INVERSE_KERNEL_H_
